---------------------------------------------------------------------------------- 
-- Engineer: Catherine Lagunzad
-- Create Date: 10/29/2017 07:50:25 PM
-- Description: 
----------------------------------------------------------------------------------
--------------------------------------------
--T FLIP-FLOP
--------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity t_flip_flop is
    Port ( EN : in STD_LOGIC;
           T : in STD_LOGIC;
           T_initial : in STD_LOGIC;
           CLK : in STD_LOGIC;
           Q : out STD_LOGIC;
           Qn : out STD_LOGIC);
end t_flip_flop;

architecture Behavioral of t_flip_flop is

--intermediate signal initialization
signal t_Q : STD_LOGIC := T_initial;

begin
    process (EN, T, CLK)
    begin
        --button is pressed
        if (EN = '0') then
            t_Q <= t_Q;
        else
            if (rising_edge(CLK)) then
                t_Q <= (T xor t_Q);
            end if;
        end if;
    end process;
    Q <= t_Q;
    Qn <= NOT t_Q;
end Behavioral;
