----------------------------------------------------------------------------------
-- Company: 
-- Create Date: 11/29/2017 12:53:49 PM
-- Description: outputs a beep when the countdown timer reaches 0
-- NOTE: the speaker works, but watch out for pins that don't work, so use
-- as many output pins for the speaker as you want to check that if functions.
-- this code was completed with the help of a reddit forum found on this website
-- https://stackoverflow.com/questions/22767256/vhdl-code-for-single-octave-digital-piano
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity buzzer_tone is
    Port ( EN : in STD_LOGIC;
           CLK : in STD_LOGIC;
           speaker : out STD_LOGIC;
           speaker_LED : out STD_LOGIC);
end buzzer_tone;

architecture Behavioral of buzzer_tone is
    signal temp_count : INTEGER:= 0;
    signal clk_440hz : STD_LOGIC:= '0';
    
begin
    process (EN, CLK)       --CONVERT 10ns to 440hz (A note)
    begin
        if (rising_edge(CLK)) then
            if temp_count < 227272 then     --100,000,000Hz/227272Hz = 440Hz
                temp_count <= temp_count + 1;
            else
                clk_440hz <= not clk_440hz;
                temp_count <= 0;
            end if;
        end if;
    end process;
    
    sound_proc: process(EN, CLK)
    begin
        if (EN = '0') then          --speaker is off
            speaker_LED <= '0';
            speaker <= '0';
        elsif (EN = '1') then       --speaker is on
            speaker_LED <= '1';
            speaker <= clk_440hz;
        end if;
    end process;

end Behavioral;
